# -*- encoding: utf-8 -*-
# stub: studio_game_2021 1.0.0 ruby lib

Gem::Specification.new do |s|
  s.name = "studio_game_2021".freeze
  s.version = "1.0.0"

  s.required_rubygems_version = Gem::Requirement.new(">= 0".freeze) if s.respond_to? :required_rubygems_version=
  s.require_paths = ["lib".freeze]
  s.authors = ["Becca Williams".freeze]
  s.date = "2021-05-05"
  s.description = "\n<!-- TABLE OF CONTENTS -->\n<details open=\"open\">\n<summary>Table of Contents</summary>\n<ol>\n<li>\n<a href=\"#about-the-project\">About The Project</a>\n<ul>\n<li><a href=\"#built-with\">Built With</a></li>\n</ul>\n</li>\n<li>\n<a href=\"#getting-started\">Getting Started</a>\n<ul>\n<li><a href=\"#prerequisites\">Prerequisites</a></li>\n<li><a href=\"#installation\">Installation</a></li>\n</ul>\n</li>\n<li><a href=\"#usage\">Usage</a></li>\n<li><a href=\"#roadmap\">Roadmap</a></li>\n<li><a href=\"#contributing\">Contributing</a></li>\n<li><a href=\"#license\">License</a></li>\n<li><a href=\"#contact\">Contact</a></li>\n<li><a href=\"#acknowledgements\">Acknowledgements</a></li>\n</ol>\n</details>\n\n<!-- ABOUT THE PROJECT -->\n## About The Project\n\n[![Product Name Screen Shot][Screenshot of gameplay and test list]](https://www.dropbox.com/s/mu1rrbx2mqowjkn/studio-game.png?dl=0)\n\nThis game is a project built following the [Pragmatic Studio Ruby Course](https://online.pragmaticstudio.com/courses/ruby/). I absolutely adored going through this course, because it was unlike other courses in that the main focus wasn't syntax, but how to build a principle-driven, object-oriented program that contains many of the skills we'd need to build real-world projects. The instructors purposefully created exercises to let us build a program using the skills they demonstrated by building a different program. This wasn't a copy and paste kind of course. This game was actually my second run-through, where I test-drove everything from the start based on the objectives only.\n\nSkills I valued developing further with this project:\n- Test-driven development (50+ tests).\n- Using inheritance to model \"is-a\" relationships. For example, a clumsy player *is a* kind of player.\n- Using mixins (modules) to reuse behaviours that are common between classes, but should not be modeled with an inheritance relationship. A good tip was to look for 'able' behaviors in a class to extract, like 'playable', 'printable', 'taxable' etc.\n- Using a file block which lets you add in class usage examples that are only run when you run the class file specifically.\n- Overriding default methods (like sort, and renaming things so that they keep a specific format)\n\nThings I struggled with:\n- Testing behaviour that uses blocks. I had a lightbulb moment when I realised I should test the behaviour performed inside the block on a single item. Testing the output of an entire block is like testing Ruby syntax works. Alternatively, test the before and after state of something that changes as a result of using a block. Cooool.\n- Puts. It felt wrong to use puts to show the output in the console. I'd like to learn how to seperate the view logic for a command-line project later.\n\nThings I did to make it my own:\n- Wrote a lot more tests for my second run-through.\n- Noticed and extracted further 'able' behaviours into modules (like printing stats, formatting output and handling csv files).\n\n\n### Built With\n\n* [Ruby (language)](https://www.ruby-lang.org/en/)\n* [RSpec (framework)](https://rspec.info/)\n* [Vim (text-editor)](https://www.vim.org/)\n\n\n\n<!-- GETTING STARTED -->\n## Getting Started\n\nTo get a local copy up and running follow these steps:\n\n### Prerequisites\n\nThis is an example of how to list things you need to use the software and how to install them.\n* gem\n```sh\nnpm install npm@latest -g\n```\n\n### Installation\n\n1. Install the gem\n```sh\ngem install studio_game_2021\n```\n\n<!-- USAGE EXAMPLES -->\n## Usage\nTo play a game from the command-line, open a new command project and run the command-line script like so:\n```sh\nstudio_game\n```\n\nOr, if you'd like to use the game as a library, here's an example of how to use it in `irb`. You can also check the bottom of each class or module file for further usage instructions\n\n```\n>> require 'studio_game/game'\n=> true\n\n>> game = StudioGame::Game.new(\"Knuckleheads\")\n=> #<StudioGame::Game:0x007fdea10252d8 @title=\"Knuckleheads\", @players=[]>\n\n>> player = StudioGame::Player.new(\"Moe\", 90)\n=> I'm Moe with health = 90, points = 0, and score = 90.\n\n>> game.add_player(player)\n=> [I'm Moe with health = 90, points = 0, and score = 90.]\n\n>> game.play(1)\n```\n\n\n<!-- ROADMAP -->\n## Roadmap\n\nI plan to customize this game further now that I have a solid foundation to explore from. It'll be fun to let the players interact with each other more, like swapping treasures, and maybe add some kind of board game with it's own features. That's my next focus.\n\n\n## Contributing\n\nFeel free to fork this project and play around with it. Open to feedback-related pr requests.\n\n\n  <!-- LICENSE -->\n## License\n\n  Distributed under the MIT License. See `LICENSE` for more information.\n\n\n\n  <!-- CONTACT -->\n## Contact\n\n  Becca - [@becca9941](https://twitter.com/Becca9941) - becca@essentialistdev.com\n\n  Project Link: [https://gitlab.com/EssentialistDev/studio-game](https://gitlab.com/EssentialistDev/studio-game)\n\n\n\n  <!-- ACKNOWLEDGEMENTS -->\n## Acknowledgements\n\n- [Pragmatic Studio](https://online.pragmaticstudio.com/courses/ruby/) for empowering me with awesome new development skills.\n- [Best-README-Template](https://github.com/Becca9941/Best-README-Template) for helping me write a README for this project.\n".freeze
  s.email = "becca@essentialistdev.com".freeze
  s.executables = ["studio_game".freeze]
  s.files = ["bin/studio_game".freeze]
  s.homepage = "https://gitlab.com/EssentialistDev/studio-game".freeze
  s.licenses = ["MIT".freeze]
  s.required_ruby_version = Gem::Requirement.new(">= 1.9".freeze)
  s.rubygems_version = "3.2.22".freeze
  s.summary = "A text-based game".freeze

  s.installed_by_version = "3.2.22" if s.respond_to? :installed_by_version

  if s.respond_to? :specification_version then
    s.specification_version = 4
  end

  if s.respond_to? :add_runtime_dependency then
    s.add_development_dependency(%q<rspec>.freeze, ["~> 2.8", ">= 2.8.0"])
  else
    s.add_dependency(%q<rspec>.freeze, ["~> 2.8", ">= 2.8.0"])
  end
end
